#include <acknex.h>

STRING* str1 = "GOAL: Catch the red Ball";
STRING* str2 = "Use WASD to move";
STRING* str3 = "Use R to set yourself to the starting point and to create a new red Ball";
STRING* str4 = "Press the MiddleMouse Button and move the Mouse to rotate camera arround the player";
STRING* str5 = "PRESS any key to start game";
STRING* str6 = "For Help press F1";

FONT* arial_font = "Arial#16"; 
FONT* arial_font_b = "Arial#30b"; 

TEXT* help = 
{
	strings = 6;
	string(str1,str2,str3,str4,str5,str6);
	pos_x = 10;
	pos_y = 10;
	font = arial_font;
	flags =(SHOW);
}
STRING* score1 = "CATCHED BALLS:";
STRING* score2 = "00000";
STRING* score3 = "FREE BALLA";
STRING* score4 = "00001";
STRING* score5 = "SECONDS TO NEXT SPAN";
STRING* score6 = "00000";
STRING* score7 = "TOTAL TIME";
STRING* score8 = "00000";
TEXT* score = 
{
	strings = 4;
	string(score1,score2,score3,score4);
	pos_x = 10;
	pos_y = 10;
	font = arial_font;
//	flags =();
}
TEXT* time = 
{
	strings = 4;
	string(score5,score6,score7,score8);
	pos_x = 310;
	pos_y = 10;
	font = arial_font;
//	flags =();
}
TEXT* win =
{
	strings = 3;
	string("   !!You have won!!    ",
		  	 "   It's enough now     ",
		  	 "   Try another game    ");
	pos_x = 300;
	pos_y = 290;
	font = arial_font_b;
	flags =(/*SHOW | */SHADOW | OUTLINE | TRANSLUCENT);
}
TEXT* catch =
{
	strings = 1;
	string("!!!GOT YOU!!!");
	pos_x = 310;
	pos_y = 310;
	font = arial_font_b;
	flags =(/*SHOW | */SHADOW | OUTLINE | TRANSLUCENT);
}
TEXT* restart =
{
	strings = 1;
	string("!!!NEXT ROUND!!!");
	pos_x = 310;
	pos_y = 310;
	font = arial_font_b;
	flags =(/*SHOW | */SHADOW | OUTLINE | TRANSLUCENT);
}
TEXT* level_up =
{
	strings = 1;
	string("!!!NEXT LEVEL!!!");
	pos_x = 310;
	pos_y = 310;
	font = arial_font_b;
	flags =(/*SHOW | */SHADOW | OUTLINE | TRANSLUCENT);
}
TEXT* span =
{
	strings = 2;
	string("!!!NEXT ENEMY!!!",
			 "   !CATCH ME!  ");
	pos_x = 310;
	pos_y = 310;
	font = arial_font_b;
	flags =(/*SHOW | */SHADOW | OUTLINE | TRANSLUCENT);
}
TEXT* game_over =
{
	strings = 3;
	string("   !!!GAME OVER!!!   ", 
			 "   TOO MUCH ENEMYS   ",
			 "YOU WANT GET THEM ALL");
	pos_x = 310;
	pos_y = 310;
	font = arial_font_b;
	flags =(/*SHOW | */SHADOW | OUTLINE | TRANSLUCENT);
}
function show_text(var* text_num)// 0 win , 1 catch , 2 restart, 3 span, 4 level_up, 5 game over
{
		if(text_num==0)
		{
			win.alpha=0;
			freeze_mode=1;
			set(win,SHOW);
			while(win.alpha<=100)
			{
				win.alpha+=0.5*time_step;
			}
			wait(-10);
			while(win.alpha>=0)
			{
				win.alpha-=0.5*time_step;
			}
			reset(win,SHOW);
			sys_exit("");
		}
		if(text_num==1)
		{
			catch.alpha=0;
			set(catch,SHOW);
			while(catch.alpha<=100)
			{
				catch.alpha+=0.5*time_step;
			}
			wait(-2);
			while(catch.alpha>=0)
			{
				catch.alpha-=0.5*time_step;
			}
			reset(catch,SHOW);
		}
		if(text_num==2)
		{
			restart.alpha=0;
			set(restart,SHOW);
			while(restart.alpha<=100)
			{
				restart.alpha+=0.5*time_step;
			}
			wait(-2);
			while(restart.alpha>=0)
			{
				restart.alpha-=0.5*time_step;
			}
			reset(restart,SHOW);
		}
		if(text_num==3)
		{
			span.alpha=0;
			set(span,SHOW);
			while(span.alpha<=100)
			{
				span.alpha+=0.5*time_step;
			}
			wait(-2);
			while(span.alpha>=0)
			{
				span.alpha-=0.5*time_step;
			}
			reset(span,SHOW);
		}
		if(text_num==4)
		{
			level_up.alpha=0;
			set(level_up,SHOW);
			while(level_up.alpha<=100)
			{
				level_up.alpha+=0.5*time_step;
			}
			wait(-2);
			while(level_up.alpha>=0)
			{
				level_up.alpha-=0.5*time_step;
			}
			reset(level_up,SHOW);
		}
		if(text_num==5)
		{
			game_over.alpha=0;
			freeze_mode=1;
			set(game_over,SHOW);
			while(game_over.alpha<=100)
			{
				game_over.alpha+=0.5*time_step;
			}
			wait(-10);
			while(game_over.alpha>=0)
			{
				game_over.alpha-=0.5*time_step;
			}
			reset(game_over,SHOW);
			sys_exit("");
		}
}
function Toggle_Help_screen()
{
	toggle(help,SHOW);
	toggle(score,SHOW);
	toggle(time,SHOW);
}