#include <acknex.h>
#include <default.c>
#include "Text.c"

var kill_count = 0;
var free_count = 1;

var span_time = 100;
var total_time = 0;

var span_duration = 100;

function AI_event()// the event of the AI
{
	VECTOR diff;
	if(event_type==EVENT_IMPACT)
	{
		if(you==player)
		{
			kill_count+=1;
			str_for_num(score2,kill_count);
			free_count-=1;
			str_for_num(score4,free_count);
			ent_remove(me);
			show_text(1);
		}
		else
		{
			VECTOR direction;
			vec_set(direction,bounce);
			vec_inverse(direction);//inverse the bounce VECTOr so that you have the Movement VECTOR of the player
			c_move(me,nullvector,direction,IGNORE_YOU);// moves the Box
		}
		
	}
}

function posInDanger(ENTITY* ent,VECTOR* pos)
{
	me = ent;
	VECTOR distance;
	var length;
	vec_diff(distance,player.x,pos);
	length = vec_length(distance);
	if(abs(length)<=96)
	{
		c_trace(pos,player.x,IGNORE_ME);
		if(player==you)return 1;
	}
	else return 0;
}

action enemy_AI()// action of the AI
{
	me.emask = (ENABLE_IMPACT);
	me.event = AI_event;
	set(me,SHADOW);
	wait(1);
	c_setminmax(me);
	while(1)
	{
		if(posInDanger(me,me.x))
		{
			var i = 0;
			var Protection = 0;
			VECTOR target_points[8];
			for(i=0;i<8;i++)
			{
				VECTOR trace_vec;
				VECTOR target_vec;
				trace_vec.x = me.x + fcos(i*45,19);
				trace_vec.y = me.y + fsin(i*45,19);
				trace_vec.z = me.z;
				c_trace(me.x,trace_vec,IGNORE_ME|USE_BOX);
				if(result)vec_set(target_vec,target);
				else vec_set(target_vec,trace_vec);
				if(!posInDanger(me,target_vec))
				{
					VECTOR temp;
					vec_diff(temp,target_vec,me.x);
					c_move(me,nullvector,temp,IGNORE_PASSABLE);
					Protection = 1;
					break;
				}
				else
				{
					vec_set(target_points[i],target_vec);
				}
			}
			if(Protection==0)
			{	
				VECTOR target_points_two[8][8];
				for(i=0;i<8;i++)
				{
					var a = 0;
					for(a=0;a<8;a++)
					{
						VECTOR trace_vec;
						VECTOR target_vec;
						trace_vec.x = target_points[i].x + fcos(a*45,19);
						trace_vec.y = target_points[i].y + fsin(a*45,19);
						trace_vec.z = target_points[i].z;
						c_trace(target_points[i],trace_vec,IGNORE_ME|USE_BOX);
						if(result)vec_set(target_vec,target);
						else vec_set(target_vec,trace_vec);
						if(!posInDanger(me,target_vec))
						{
							VECTOR temp;
							vec_diff(temp,target_points[i],me.x);
							c_move(me,nullvector,temp,IGNORE_PASSABLE);
							Protection = 1;
							break;
						}
						vec_set(target_points_two[i][a],target_vec);
					}
				}
				if(Protection==0)
				{	
					VECTOR target_points_two[8][8];
					for(i=0;i<8;i++)
					{
						var a = 0;
						for(a=0;a<8;a++)
						{
							var b;
							for(b=0;b<8;b++)
							{
								
								VECTOR trace_vec;
								VECTOR target_vec;
								trace_vec.x = target_points_two[i][a].x + fcos(a*45,19);
								trace_vec.y = target_points_two[i][a].y + fsin(a*45,19);
								trace_vec.z = target_points_two[i][a].z;
								c_trace(target_points_two[i][a],trace_vec,IGNORE_ME|USE_BOX);
								if(result)vec_set(target_vec,target);
								else vec_set(target_vec,trace_vec);
								if(!posInDanger(me,target_vec))
								{
									VECTOR temp;
									vec_diff(temp,target_points[i],me.x);
									c_move(me,nullvector,temp,IGNORE_PASSABLE);
									Protection = 1;
									break;
								}
							}
						}
					}
				}
			}
		}
		wait(1);
	}
}

var fieldx[121] =   { 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,	
							 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
							 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
							 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
							 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
							-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,
							-3,-3,-3,-3,-3,-3,-3,-3,-3,-3,-3,
							-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,
							-5,-5,-5,-5,-5,-5,-5,-5,-5,-5,-5};

var fieldy[121] =   { 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5,
							 5, 4, 3, 2, 1, 0,-1,-2,-3,-4,-5};

ANGLE cameraang;
function camera_start(ENTITY* ent)
{
	me = ent;
	while(1)
	{
		vec_set(camera.x,vector(0,0,200));//sets the camera to the normal position
		vec_rotate(camera.x,cameraang);// rotates the camera arpund an ANGLE
		vec_add(camera.x,me.x);// moves the camera to the player
		wait(1);
	}
}
action player_movement()//the player movement
{
	player = me;
	set(me,SHADOW);
	wait(2);
	c_setminmax(me);
	camera_start(me);
	while(1)
	{
		var steps = 0;
		//sets on which keys the player should move
		if(key_w)c_move(me,nullvector,vector(19,0,0),ACTIVATE_PUSH);//sets on which keys the player should move
		if(key_s)c_move(me,nullvector,vector(-19,0,0),ACTIVATE_PUSH);
		if(key_a)c_move(me,nullvector,vector(0,19,0),ACTIVATE_PUSH);
		if(key_d)c_move(me,nullvector,vector(0,-19,0),ACTIVATE_PUSH);
		if (key_any)wait(-0.1);
		else	wait(1);
	}
}
function Box_normal_event()//event of the boxes
{
	if(event_type = EVENT_IMPACT)
	{
		if(you==player)//if the player pushes/hits the box
		{
			VECTOR direction;
			vec_set(direction,bounce);
			vec_inverse(direction);//inverse the bounce VECTOr so that you have the Movement VECTOR of the player
			c_move(me,nullvector,direction,IGNORE_YOU);// moves the Box
		}
	}
}
function Box_flummi_event()//event of the boxes
{
	if(event_type = EVENT_IMPACT)
	{
		if(you==player)//if the player pushes/hits the box
		{
			VECTOR direction;
			vec_set(direction,bounce);
			vec_inverse(direction);//inverse the bounce VECTOr so that you have the Movement VECTOR of the player
			c_move(me,nullvector,direction,IGNORE_YOU);// moves the Box
			c_move(player,nullvector,bounce,IGNORE_PASSABLE);// moves the Box
		}
	}
}
action Box_action()//action of the boxes
{
	set(me,SHADOW);
	wait(1);
	c_setminmax(me);
	if(me.x==0&&me.y==0)
	{
		ent_morphskin(me,"Beton.bmp");
	}
	else
	{
	var ran = integer(random(3));
	if(ran == 0)
	{
		me.emask = ENABLE_IMPACT;
		me.event = Box_normal_event;
		ent_morphskin(me,"Woodskin.bmp");
	}
	if(ran == 1)
	ent_morphskin(me,"Beton.bmp");
	
	if(ran == 2)
	{
		me.emask = ENABLE_IMPACT;
		me.event = Box_flummi_event;
		ent_morphskin(me,"Flummi.bmp");
	}
	}
}

function span_Box()
{
	var i;
	for(i=0;i<121;i++)
	{
		ent_create("Box.mdl",vector(fieldx[i]*38,fieldy[i]*38,8),Box_action);
	}
	return 1;
}
function span_KI()
{
	show_text(2);
	ent_create("BallRed.mdl",vector(-18,0,8),enemy_AI);
	free_count+=1;
	str_for_num(score4,free_count);
	span_time = span_duration;
	vec_set(player.x,vector(18,0,8));
}


function UpdateSpanDuration()
{
		switch(kill_count)
		{
			case 2:
				span_duration = 90;
				show_text(4);
				break;
			case 4:
				span_duration = 80;
				show_text(4);
				break;
			case 8:
				span_duration = 60;
				show_text(4);
				break;
			case 16:
				span_duration = 20;
				show_text(4);
				break;
			case 32:
				span_duration = 10;
				show_text(4);
				break;
			case 64:
				span_duration = 5;
				show_text(4);
				break;
			case 128:
				span_duration = 2;
				show_text(4);
				break;
			case 256:
				span_duration = 0.5;
				show_text(4);
				break;
			case 512:
				show_text(0);
			break;
			default:
				break;
		}
		
//	}
}
function span_timer()
{
	while(1)
	{
		wait(-1);
		span_time--;
		total_time++;
		str_for_num(score8,total_time);
		if(free_count>= 10)show_text(5);
		UpdateSpanDuration();
		if(span_time<=0)
		{
			span_time = span_duration;
			ent_create("BallRed.mdl",vector(-18,0,8),enemy_AI);
			free_count++;
			show_text(3);
			str_for_num(score4,free_count);
		}	
		str_for_num(score6,span_time);
	}
}
function main()
{
	ENTITY* sky = ent_createlayer("skycube+6.dds", SKY | CUBE | SHOW, 0);
	max_particles= 20000;
	video_mode=6;
	level_load("flatter.hmp");
	camera.tilt = -5;
	camera.z=50;
	camera.x= -300;
	span_Box();	

	
	while(!key_any)
	{
		camera.pan += 0.1*time_step;
		vec_rotate(camera.x,vector(0.1*time_step,0,0));
		wait(1);
	}
	camera.pan = 0;
	camera.tilt = -90;
	str_for_num(score2,kill_count);
	Toggle_Help_screen();
	on_f1 = Toggle_Help_screen;
	ent_create("BallRed.mdl",vector(-18,0,8),enemy_AI);
	ent_create("BallYellow.mdl",vector(18,0,8),player_movement);
	span_timer();
	on_r=span_KI;
	while(1)
	{
		if(mouse_middle)
		{
			camera.pan+=mickey.x;
			if((cameraang.tilt<90)&&(cameraang.tilt>0))cameraang.tilt+=mickey.y;
			else
			{
				if((cameraang.tilt>=90)&&(mickey.y<0))cameraang.tilt+=mickey.y;
				if((cameraang.tilt<=0)&&(mickey.y>0))cameraang.tilt+=mickey.y;
			}
			camera.tilt=cameraang.tilt-90;
		}
	cameraang.pan = camera.pan;
	wait(1);
	}
}